/*
** Module   :CALCSTAT.CMD
** Abstract :Calc all time & bytes user.log
**
** Copyright (C) mmdl develpers
**
** Log: Thu  15/02/2001 Created
**
*/

Parse arg inputfile
If inputfile="" Then
Do
  Say " CS version v0.0.1 "
  Say "Generate statistic of month"
  Say "USAGE: CS.CMD sfppp_log_filename"
  Say ""
  Exit
End

outputfile="stat"

"@del "||outputfile||".all 1> nul 2>&1"

/* ⤥塞   ⫥ */
Do While Lines(inputfile) > 0
Entry = Linein(inputfile)
Parse var entry days '/' month '/' year hour ':' minutes ':' seconds .'.'. 'User'.'logged' event .
if event="out." then
do
noecho = Lineout(outputfile||".tmp",entry)
end
end
call stream outputfile||".tmp",'c','close'

timeall=0
inbytesall=0
outbytesall=0
oldmonth="00"
totaltime=0
totalinbytes=0
totaloutbytes=0
noecho = Lineout(outputfile||".all","--------------------------------------------------------------------------------")
i=0
Do While Lines(outputfile||".tmp") > 0
 Entry = Linein(outputfile||".tmp")
Parse var entry days '/' month '/' year hour ':' minutes ':' seconds .'.'. 'User'.'logged out. Port=' port .'User was online' timeonline .'seconds. Inbytes=' inbytes .'Outbytes=' outbytes

i=i+1
if i=1 then oldmonth=month
if month<>oldmonth then
do
bytein=Strip(Format(inbytesall/1048576,9,2))
byteout=Strip(Format(outbytesall/1048576,9,2))
timeall=Strip(Format(timeall,9,0))
noecho = Lineout(outputfile||".all","Month "||oldmonth||" Total Time: "||Sec2time(timeall)||" ("||timeall||"), Sent: "||bytein||" Mb, Received: "||byteout||" Mb")
timeall=0
inbytesall=0
outbytesall=0
oldmonth=month
end

timeall=timeall+timeonline
inbytesall=inbytesall+inbytes
outbytesall=outbytesall+outbytes

totaltime=totaltime+timeonline
totalinbytes=totalinbytes+inbytes
totaloutbytes=totaloutbytes+outbytes
end

bytein=Strip(Format(inbytesall/1048576,9,2))
byteout=Strip(Format(outbytesall/1048576,9,2))
timeall=Strip(Format(timeall,9,0))
noecho = Lineout(outputfile||".all","Month "||oldmonth||" Total Time: "||Sec2time(timeall)||" ("||timeall||"), Sent: "||bytein||" Mb, Received: "||byteout||" Mb")



bytein=Strip(Format(totalinbytes/1048576,9,2))
byteout=Strip(Format(totaloutbytes/1048576,9,2))
timeall=Strip(Format(totaltime,9,0))

noecho = Lineout(outputfile||".all","--------------------------------------------------------------------------------")
noecho = Lineout(outputfile||".all","Total Time: "||Sec2time(timeall)||" ("||timeall||"), Sent: "||bytein||" Mb, Received: "||byteout||" Mb")

call stream outputfile||".all",'c','close'
call stream outputfile||".tmp",'c','close'
"@del "||outputfile||".tmp"
exit



Sec2time:
Parse Arg Sec

ss=Sec/3600
if POS('.',ss)=0 then
	do
	H=ss
	end
	else
	do
	H=SUBSTR(ss,1,POS('.',ss)-1)
	end
ss=(Sec-H*3600)/60
if POS('.',ss)=0 then
	do
	M=ss
	end
	else
	do
	M=SUBSTR(ss,1,POS('.',ss)-1)
	end
S=Strip(Format(Sec-H*3600-M*60,9,0))
return H||":"||M||":"||S
